/**
* @module @promises/_create-reduce
* @copyright © 2017 Yisrael Eliav <yisraelx@gmail.com> (https://github.com/yisraelx)
* @license MIT
*/
/**
* @module @pakal/keys
* @copyright © 2018 Yisrael Eliav <yisraelx@gmail.com> (https://github.com/yisraelx)
* @license MIT
*/
var hasEnumBug = !({ toString: null }).propertyIsEnumerable('toString'), enumsBugProps = [
    'toString',
    'toLocaleString',
    'valueOf',
    'hasOwnProperty',
    'isPrototypeOf',
    'propertyIsEnumerable',
    'constructor'
], hasOwnProperty = Object.prototype.hasOwnProperty;
function keys(object) {
    object = typeof object === 'string' ? object.split('') : object;
    var result = [];
    if (Object(object) !== object) {
        return result;
    }
    for (var key in object) {
        if (hasOwnProperty.call(object, key)) {
            result.push(key);
        }
    }
    if (hasEnumBug) {
        var index = enumsBugProps.length;
        while (--index >= 0) {
            var key = enumsBugProps[index];
            if (hasOwnProperty.call(object, key)) {
                result.push(key);
            }
        }
    }
    return result;
}

function _createReduce(rtl) {
    return function (collection, iteratee = v => v, accumulator) {
        let init = arguments.length < 3;
        return Promise.resolve(collection).then((collection = []) => {
            let objectKeys = !Array.isArray(collection) && keys(collection);
            let { length } = objectKeys ? objectKeys : collection;
            let left = 0;
            let right = length - 1;
            let each = Promise.resolve(accumulator);
            while (left <= right) {
                let current = rtl ? right-- : left++;
                each = each.then((accumulator) => {
                    let key = objectKeys ? objectKeys[current] : current;
                    let value = collection[key];
                    return Promise.resolve(value).then((value) => {
                        return init ? (init = false, value) : iteratee(accumulator, value, key, collection);
                    });
                });
            }
            return each;
        });
    };
}

export default _createReduce;
//# sourceMappingURL=index.es6.js.map
