/**
* @module @promises/_create-reduce
* @copyright © 2017 Yisrael Eliav <yisraelx@gmail.com> (https://github.com/yisraelx)
* @license MIT
*/
/**
* @module @pakal/keys
* @copyright © 2018 Yisrael Eliav <yisraelx@gmail.com> (https://github.com/yisraelx)
* @license MIT
*/
var hasEnumBug = !({ toString: null }).propertyIsEnumerable('toString'), enumsBugProps = [
    'toString',
    'toLocaleString',
    'valueOf',
    'hasOwnProperty',
    'isPrototypeOf',
    'propertyIsEnumerable',
    'constructor'
], hasOwnProperty = Object.prototype.hasOwnProperty;
function keys(object) {
    object = typeof object === 'string' ? object.split('') : object;
    var result = [];
    if (Object(object) !== object) {
        return result;
    }
    for (var key in object) {
        if (hasOwnProperty.call(object, key)) {
            result.push(key);
        }
    }
    if (hasEnumBug) {
        var index = enumsBugProps.length;
        while (--index >= 0) {
            var key = enumsBugProps[index];
            if (hasOwnProperty.call(object, key)) {
                result.push(key);
            }
        }
    }
    return result;
}

function _createReduce(rtl) {
    return function (collection, iteratee, accumulator) {
        if (iteratee === void 0) { iteratee = function (v) { return v; }; }
        var init = arguments.length < 3;
        return Promise.resolve(collection).then(function (collection) {
            if (collection === void 0) { collection = []; }
            var objectKeys = !Array.isArray(collection) && keys(collection);
            var length = (objectKeys ? objectKeys : collection).length;
            var left = 0;
            var right = length - 1;
            var each = Promise.resolve(accumulator);
            var _loop_1 = function () {
                var current = rtl ? right-- : left++;
                each = each.then(function (accumulator) {
                    var key = objectKeys ? objectKeys[current] : current;
                    var value = collection[key];
                    return Promise.resolve(value).then(function (value) {
                        return init ? (init = false, value) : iteratee(accumulator, value, key, collection);
                    });
                });
            };
            while (left <= right) {
                _loop_1();
            }
            return each;
        });
    };
}

export default _createReduce;
//# sourceMappingURL=index.esm.js.map
