"use strict";
/**
 * @module @promises/_create-reduce
 * @copyright © 2017 Yisrael Eliav <yisraelx@gmail.com> (https://github.com/yisraelx)
 * @license MIT
 */
Object.defineProperty(exports, "__esModule", { value: true });
var keys_1 = require("@pakal/keys");
/**
 * @function
 * @private
 */
function _createReduce(rtl) {
    return function (collection, iteratee, accumulator) {
        if (iteratee === void 0) { iteratee = function (v) { return v; }; }
        var init = arguments.length < 3;
        return Promise.resolve(collection).then(function (collection) {
            if (collection === void 0) { collection = []; }
            var objectKeys = !Array.isArray(collection) && keys_1.default(collection);
            var length = (objectKeys ? objectKeys : collection).length;
            var left = 0;
            var right = length - 1;
            var each = Promise.resolve(accumulator);
            var _loop_1 = function () {
                var current = rtl ? right-- : left++;
                each = each.then(function (accumulator) {
                    var key = objectKeys ? objectKeys[current] : current;
                    var value = collection[key];
                    return Promise.resolve(value).then(function (value) {
                        return init ? (init = false, value) : iteratee(accumulator, value, key, collection);
                    });
                });
            };
            while (left <= right) {
                _loop_1();
            }
            return each;
        });
    };
}
exports.default = _createReduce;
//# sourceMappingURL=index.js.map